package com.mindoo.dde.imageproperties.tools;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * Class offering methods to extract text from a DOM-Node.
 * 
 * @author Tammo Riedinger
 */
public class NodeTextExtractor {
	/**
	 * Extracts text contained in a child node.
	 * 
	 * @param node 				parent node
	 * @return String			the text
	 */
	public static String getTextContent(Element node) {
		StringBuffer sb = new StringBuffer();
		NodeList childNodes = node.getChildNodes();
		
		for (int i=0; i<childNodes.getLength(); i++) {
			Node currChild = childNodes.item(i);
			if (currChild.getNodeType() == Node.TEXT_NODE) {
				sb.append(currChild.getNodeValue());
			}
			else if (currChild.getNodeType() == Node.CDATA_SECTION_NODE) {
				sb.append(currChild.getTextContent());
			}
		}
		
		return sb.toString();
	}	
}
